10 REM ----- initializations --------------------------------
11 rem [][][] color [][][] : nuclr=8
12 CLS
14 DEFINT A-Z
15 ON ERROR GOTO 200
16 KEY OFF:SCREEN 1:COLOR nuclr,0
18 REM ------ arrays ----------------------------------------
20 DIM PROG(150,18)    :REM ** where program is stored
21 DIM NEWPROG(150,18) :REM ** where program being edited is stored
22 REM  [for both above - element (0,0)=biggest line number  ]
23 REM  [               - element (y,0)=0 if line is empty   ]
24 DIM BEAN(7)         :REM ** bean graphic for registers
26 DIM REG(11)         :REM ** register contents
28 DIM CRSR(14)        :REM ** cursor graphic
30 DIM LTR(60)         :REM ** used in letter inversion
32 DIM WINDO(2500)     :REM ** window array for scrolling
34 DIM TOPW(900)       :REM ** top of window for scrolling
36 DIM TRTLRT(14)      :REM ** turtle facing right
38 DIM TRTLLF(14)      :REM ** turtle facing leftt
40 DIM LOGO(1800)      :REM ** for my logo
50 REM ------ some constants ----------------------------------
52 SPOT = 16          :REM top right of display window
54 SPACE = 0          :REM 0 if interpreting basic
56 REM SPACE =32          :REM 32 if compiling basic
58 REM -- get delay constant ---
60 DEF SEG = &HF000
62 COMP=PEEK(&HFFFE)
64 IF COMP>252 AND COMP<256 THEN DELAY = 4310:D2=4 :REM PC,PC XT or PC Jr
66 IF COMP =252 THEN DELAY = 10000:D2=3       :REM PC AT
70 DEF SEG
76 REM  ------ assignment of graphics ----------------------------
78 GET (0,0)-STEP(50,40),WINDO
80 LOCATE 1,1:PRINT CHR$(16)
82 GET (0,0)-STEP(7,7),TRTLRT
84 LOCATE 1,1:PRINT CHR$(17)
86 GET (0,0)-STEP(7,7),TRTLLF
90 LINE (0,0)-STEP(4,1),1,B
92 GET (0,0)-STEP(4,1),BEAN
94 LINE (0,0)-STEP(7,7),1,BF
96 GET (0,0)-STEP(7,7),CRSR
98 BLOAD "all_l.ogo",VARPTR(LOGO(0))
100 OLDREGSFLAG=0
102 SAUND=1
104 GOTO 900
200 REM **************************
205 REM * Error Trapping Routine *
210 REM *   for Load/Save        *
215 REM **************************
240 GET (116,149)-STEP(186,36),WINDO
245 PUT (116,149),WINDO,XOR
250 IF ERR=53 THEN RUNERR=3:REM ** File not Found
255 IF ERR=61 THEN RUNERR=4:REM ** Disk Full
260 IF ERR=72 THEN RUNERR=5:REM ** Defective disk
265 IF ERR=71 THEN RUNERR=6:REM ** Disk not Ready
270 IF ERR=70 THEN RUNERR=7:REM ** Disk Write protected
275 GOSUB 7380
280 RESUME 6700
350 REM ****************************
352 REM * Clear Windo Array        *
354 REM *   substitute for 'ERASE' *
356 REM ****************************
360 FOR S=0 TO 2000
365   WINDO(S)=0
370 NEXT S
375 RETURN
400 REM *******************************
402 REM * store registers graphically *
404 REM *  for change of Mode M-S-W   *
406 REM *******************************
420 GET (0,3)-STEP (65,190),WINDO
425 OLDREGSFLAG=1: REM ** indicates that regs were stored
430 RETURN
450 REM ******************************
452 REM * redraw registers (see 400) *
454 REM ******************************
465 PUT (0,3),WINDO,PSET
470 OLDREGSFLAG=0: REM ** no regs stored
475 RETURN
500 REM ******************
501 REM * DRAW REGISTERS *
502 REM ******************
520 FOR Y=1 TO 12
525   IF Y<11 THEN LOCATE Y*2,7:PRINT Y-1;
530   IF Y>10 THEN LOCATE Y*2,6:PRINT Y-1;
535   TL=(Y-1)*16+3
538   LINE (0,TL)-STEP(65,14),2,B
540 LINE (40,TL)-STEP(0,14),2
545 NEXT Y
547 RETURN
550 REM ***************
551 REM * DRAW WINDOW *
552 REM ***************
555 LINE (115,20)-STEP(150,120),1,B
560 RETURN
565 REM ********************
566 REM * Pick Rnd Numbers *
567 REM ********************
570 RANDOMIZE -27455
572 INS = 2
575 FOR RG=0 TO 11
578   REG(RG)=0
580   VALUE=INT(RND*10)
583 REM IF MODFLAG=1 THEN REG(RG)=VALUE:GOSUB 2800:GOTO 605
585   FOR Y=0 TO VALUE
590      REG(RG)=REG(RG)+1
595      GOSUB 2800
600   NEXT Y
605 NEXT RG
610 RETURN
630 REM *******************************
632 REM * print options for Step Mode *
634 REM *******************************
645 REM LOCATE 6,35:PRINT"Edit";
650 LOCATE 8,35:PRINT"Main";
655 LOCATE 10,35:PRINT"Walk";
660 LOCATE 12,35:PRINT"Run";
665 LOCATE 14,35:PRINT"Put";
670 FOR Y=55 TO 103 STEP 16
675   GET (271,Y)-STEP(8,8),LTR
680   PUT (271,Y),LTR,PRESET
685 NEXT Y
690 RETURN
700 REM ***********************************
702 REM * print options for Walk/Run Mode *
704 REM ***********************************
710 LOCATE 5,35:PRINT"Main";
715 LOCATE 7,35:IF MODFLAG THEN PRINT"Run"; ELSE PRINT"Walk";
720 LOCATE 9,35:PRINT"Load";
725 LOCATE 11,35:PRINT"Save";
730 LOCATE 13,35:PRINT"Put";
735 LOCATE 15,35:PRINT"Edit";
740 LOCATE 17,35:PRINT"Xample";
755 FOR Y=31 TO 127 STEP 16
760   GET (271,Y)-STEP(8,8),LTR
765   PUT (271,Y),LTR,PRESET
770 NEXT Y
785 RETURN
800 REM *******************************
802 REM * print options for Main Menu *
804 REM *******************************
805 REM * saund = 1 when sound ON     *
806 REM * saund =-1 when sound OFF    *
807 REM *******************************
810 LOCATE 6,21:PRINT"Step";
815 LOCATE 8,21:PRINT"Walk";
820 LOCATE 10,21:PRINT"Run";
825 LOCATE 12,21:PRINT"Quit";
827 IF SAUND=1 THEN LOCATE 14,21:PRINT"Sound On":GOTO 830
828 LOCATE 14,21:PRINT"Sound Off"
830 FOR Y=39 TO 91 STEP 16
835   GET (159,Y)-STEP(8,8),LTR
840   PUT (159,Y),LTR,PRESET
845 NEXT Y
850 GET (207,103)-STEP(8,8),LTR
855 PUT (207,103),LTR,PRESET
890 RETURN
900 REM ****************
902 REM * Title Screen *
904 REM ****************
905 CLS
910 LINE (116,26)-STEP(63,19),1,B
915 LOCATE 5,16:PRINT"RODREGO"
920 LOCATE 9,19:PRINT"by"
925 PUT (49,80),LOGO
935 LINE (69,133)-STEP(164,14),2,B
940 LOCATE 18,10:PRINT"Press a Key to Begin"
945 LOCATE 23,8:PRINT"(C) 1986"
950 LOCATE 24,8:PRINT"Trustees of Tufts College";
960 A$=INKEY$:IF A$="" THEN 960
1000 REM ****************
1005 REM *  Main  Menu  *
1010 REM ****************
1015 CLS:SCREEN 1
1017 COLOR nuclr,0
1020 GOSUB 550: REM draw window
1023 LOCATE 1,16:PRINT"Main Menu"
1025 GOSUB 800:REM print options
1028 REM ---- coming from Run Mode? --------------
1030 IF MODFLAG=1 THEN 1100
1033 REM ---- draw registers and pick rnd values -
1035 IF OLDREGSFLAG=0 THEN GOSUB 500:GOSUB 565
1043 REM ---- graphically recall old values ------
1045 IF OLDREGSFLAG=1 THEN GOSUB 450
1050 A$=INKEY$:IF A$="" THEN 1050
1055 IF A$="S" OR A$="s" THEN GOSUB 400:GOTO 2000
1060 IF A$="W" OR A$="w" THEN MODFLAG=0:GOSUB 400:GOTO 6000
1065 IF A$="R" OR A$="r" THEN MODFLAG=1:OLDREGSFLAG=1:GOTO 6000
1070 IF A$="Q" OR A$="q" THEN 1080
1072 IF A$="O" OR A$="o" THEN 1082
1075 SOUND 100,3:GOTO 1050
1080 CLS:END
1082 REM ---- sound option -----------------------
1084 SAUND=SAUND*-1
1086 IF SAUND=1 THEN LOCATE 14,28:PRINT"n ";:GOTO 1050
1088 LOCATE 14,28:PRINT"ff";:GOTO 1050
1100 REM ---- change Integers to Beans -----------
1105 GOSUB 500
1107 MODFLAG=0:INS=2
1110 FOR RG=0 TO 11
1113 LOCATE RG*2+2,2:PRINT "   ";
1115   VALUE=REG(RG)
1120   REG(RG)=0
1125   FOR X=1 TO VALUE
1130      REG(RG)=REG(RG)+1
1135      GOSUB 2800
1140   NEXT X
1145 NEXT RG
1150 GOTO 1050
2000 REM ***************************
2005 REM * Step Mode               *
2010 REM ***************************
2015 REM * l    :row number        *
2020 REM * spot :column number     *
2025 REM * a$   :letter inputed    *
2030 REM * ins$ :instruc. string   *
2035 REM * c$   :command (inc/deb) *
2040 REM * ins  :instruction flag  *
2045 REM *      =1 deb             *
2050 REM *      =2 inc             *
2055 REM * errstep: error msg flag *
2060 REM *      =1 Bad Command     *
2065 REM *      =2 Which Register? *
2070 REM *      =3 No Register #...*
2075 REM ***************************
2080 CLS:COLOR nuclr,0
2085 MODFLAG=3:LOCATE 1,16:PRINT"Step Mode"
2090 REM ---- draw registers and pick values ----------------------
2095 IF OLDREGSFLAG=0 THEN GOSUB 500:GOSUB 570:PRINT"why here?":STOP
2100 REM ---- draw window and print options -----------------------
2105 GOSUB 550:GOSUB 630
2110 IF OLDREGSFLAG=1 THEN GOSUB 450
2115 REM ------initilization-----------------------------------------------
2120 L=3:SPOT=16
2125 L=L+1:INS$="":NC=-1:AXBRFLAG=0
2130 IF L>15 THEN GOSUB 8000
2135 PUT ((SPOT-3)*8,(L-1)*8),TRTLRT,XOR
2140 LOCATE L,SPOT,1: PRINT "? "
2145 REM ------ BEGINNING OF INPUT LOOP ------------------------------------
2150 NC=NC+1
2155 PUT (128+NC*8,(L-1)*8),CRSR,XOR
2160  A$=INKEY$ : IF A$="" THEN 2160
2165  A=ASC(A$)
2170  IF NC=6 AND A<>13 AND A<>8 THEN SOUND 1900,3:GOTO 2160
2175  IF A=13 THEN PUT(128+NC*8,(L-1)*8),CRSR,XOR:GOTO 2230
2180  IF A=8 AND NC=0 THEN SOUND 1900,3:GOTO 2160
2185  IF A=8 THEN PUT (128+NC*8,(L-1)*8),CRSR,XOR:INS$=LEFT$(INS$,LEN(INS$)-1)
2190  IF A=8 THEN NC=NC-1:LOCATE L,SPOT+1+NC:PRINT" ":GOTO 2155
2195  IF (A<47 OR A>58) AND (A<97 OR A>122) AND (A<65 OR A>90) AND A<>32 THEN SOUND 100,3:GOTO 2160
2200  INS$=INS$+A$
2205 PUT (128+NC*8,(L-1)*8),CRSR,XOR
2210 LOCATE L,SPOT+1+NC:PRINT A$
2215 COL=COL+1
2220 GOTO 2150
2225 REM ------ END OF INPUT LOOP -----------------------------------------
2230 REM
2235 REM --------- Error Checking of Instruction--------------------------|
2240 REM
2245 PUT ((SPOT-3)*8,(L-1)*8),TRTLRT,XOR
2250 C$=LEFT$(INS$,3):LET INS=0
2255 IF C$="M" OR C$="m" AND NC=1 THEN GOSUB 400:GOTO 1000
2260 IF C$="W" OR C$="w" AND NC=1 THEN MODFLAG=0:GOSUB 400:GOTO 6000
2265 IF C$="R" OR C$="r" AND NC=1 THEN MODFLAG=1:OLDREGSFLAG=1:GOTO 6000
2270 IF C$="P" OR C$="p" AND NC=1 THEN GOSUB 3000:GOTO 2125
2275 IF C$="CLS" OR C$="cls" AND NC=3 THEN GOSUB 8095:GOTO 2125
2280 IF C$="DEB" OR C$="deb" THEN INS=1:GOTO 2300
2285 IF C$="INC" OR C$="inc" THEN INS=2:GOTO 2300
2287 IF C$="" THEN 2125
2290 ERRSTEP=1:GOTO 2390
2295 REM ------- End of Instruction Check-------------------------------|
2300 REM
2305 REM ------- Beginning of Register Value Check----------------------|
2310 REM
2315 IF NC=3 THEN 2365
2320 FLAG=0
2325 FOR X=4 TO NC
2330   A=ASC(MID$(INS$,X,1))
2333   IF X=4 AND A<>32 THEN ERRSTEP=1:GOTO 2390
2335   IF A=32 AND X<NC THEN 2360
2340   IF A=32 AND X=NC AND FLAG=1 THEN 2375
2345   IF A>47 AND A<58 AND X=4 THEN 2290
2350   IF A>47 AND A<58 AND X=NC THEN 2375
2355   IF A>47 AND A<58 AND X<NC THEN FLAG=1
2360 NEXT X
2365 ERRSTEP=2:GOTO 2390
2370 REM ----check if register value is legal---------------
2375 RG=VAL(MID$(INS$,5))
2380 IF RG>-1 AND RG<12 THEN 2500
2385 ERRSTEP=3
2390 REM ------ Error Messages for Step Mode --------------
2395 L=L+1:LOCATE L,SPOT
2400 SOUND 100,4
2405 ON ERRSTEP GOTO 2415,2420,2425
2410 LOCATE 2,2:PRINT"Bug in errstep":END
2415 PRINT"-Illegal Command ":GOTO 2125
2420 PRINT"-Which Register?":GOTO 2125
2425 PRINT"-No Register #"RG:GOTO 2125
2500 REM ****************************
2505 REM * Move Turtle to Register  *
2510 REM * before operation (see 2800)
2515 REM ****************************
2520 REM * ins    :instruction flag *
2525 REM *        =1 deb            *
2530 REM *        =2 inc            *
2535 REM * rg     :register number  *
2540 REM * reg()  :register array   *
2545 REM * newl   :y-dim for trtl   *
2550 REM * axbrflag : special flag for Interpreting program (see 6000) *
2555 REM ****************************
2560 IF MODFLAG=3 THEN THERO=L
2565 IF MODFLAG <>1 THEN 2640: REM ----- move the turtle
2570 IF INS=1 THEN 2595
2575 REM -----Inc Register--------------------------------------------
2580 REG(RG)=REG(RG)+1
2585 IF SAUND=1 THEN SOUND 1100,2:SOUND 1300,3
2590 GOTO 2610
2595 REM ------Deb Register-------------------------------------------
2600 IF REG(RG)=0 THEN SOUND 100,3:AXBRFLAG=1:GOTO 2615
2605 IF SAUND=1 THEN SOUND 1100,2:SOUND  900,3
2610 GOSUB 2800
2615 IF MODFLAG =1 THEN 2635
2620 PUT (72,(NEWL-1)*8),TRTLLF,XOR
2625 IF MODFLAG = 3 AND AXBRFLAG=1 THEN L=L+1:LOCATE L,SPOT:PRINT"- I can't do it";:GOTO 2125
2630 IF MODFLAG =3 THEN 2125
2635 RETURN
2640 REM --------------- move turtle to chosen register ---------------
2645 PUT ((SPOT-3)*8,(THERO-1)*8),TRTLRT,PSET:FOR T=1 TO DELAY:NEXT T
2650 PUT ((SPOT-3)*8,(THERO-1)*8),TRTLLF,PSET:FOR T=1 TO DELAY:NEXT T
2655 PUT ((SPOT-3)*8,(THERO-1)*8),TRTLLF,XOR
2660       FOR T=1 TO DELAY:NEXT T
2665 PUT ((SPOT-4)*8,(THERO-1)*8),TRTLLF,XOR
2670 NEWL=THERO:IF NEWL>(2*RG+2) THEN 2700
2675 WHILE (NEWL<(2*RG+2))
2680    PUT ((SPOT-4)*8,(NEWL-1)*8),TRTLLF,XOR
2685    NEWL=NEWL+1:PUT ((SPOT-4)*8,(NEWL-1)*8),TRTLLF,XOR
2690       FOR T=1 TO DELAY:NEXT T
2695 WEND:GOTO 2725
2700 WHILE (NEWL>(2*RG+2))
2705    PUT ((SPOT-4)*8,(NEWL-1)*8),TRTLLF,XOR
2710    NEWL=NEWL-1:PUT ((SPOT-4)*8,(NEWL-1)*8),TRTLLF,XOR
2715       FOR T=1 TO DELAY:NEXT T
2720 WEND
2725 FOR X=SPOT-5 TO 9 STEP -1
2730    PUT ((X+1)*8,(NEWL-1)*8),TRTLLF,XOR
2735    PUT ((X)*8,(NEWL-1)*8),TRTLLF,XOR
2740       FOR T=1 TO DELAY:NEXT T
2745 NEXT X:GOTO 2570
2800 REM ***********************
2805 REM * Operate on Register *
2810 REM ***********************
2815 REM * modflag :mode flag  *
2820 REM *         =1 Run Mode *
2825 REM * ins     :inst. flag *
2830 REM *         =1 deb      *
2835 REM *         =2 inc      *
2840 REM ***********************
2845 IF MODFLAG=1 THEN 2935
2850 IF REG(RG)=16 THEN 2895
2860 IF REG(RG)>16 THEN 2935
2865 IF REG(RG)>10 THEN 2885
2870 IF REG(RG)>5  THEN 2880
2873 REM ------if reg(rg)<16--------------------------------------
2875 PUT (1+ REG(RG)    *6,RG*16+13),BEAN,XOR:GOTO 2950
2880 PUT (1+(REG(RG)- 5)*6,RG*16+9 ),BEAN,XOR:GOTO 2950
2885 PUT (1+(REG(RG)-10)*6,RG*16+5 ),BEAN,XOR:GOTO 2950
2890 REM ------if reg(rg)=16--------------------------------------
2895 IF INS=1 THEN LOCATE RG*2+2,2:PRINT "   ";
2900 FOR Y=1 TO 5
2905   PUT (1+Y*6,RG*16+13),BEAN,XOR
2910   PUT (1+Y*6,RG*16+9 ),BEAN,XOR
2915   PUT (1+Y*6,RG*16+5 ),BEAN,XOR
2920 NEXT Y
2925 IF INS=1 THEN 2950
2930 REM ------if reg(rg)>16 or in Run Mode-----------------------
2935 IF INS=1 THEN REG(RG)=REG(RG)-1
2940 LOCATE RG*2+2,3
2941 IF REG(RG)>9 THEN LOCATE RG*2+2,2
2942 IF REG(RG)>99 THEN LOCATE RG*2+2,1
2943 IF REG(RG)>999 THEN REG(RG)=0:LOCATE RG*2+2,3
2944 PRINT REG(RG);
2945 IF REG(RG)>99 THEN LINE (0,(RG)*16+3)-STEP(0,14),2
2947 RETURN
2950 IF INS=1 THEN REG(RG)=REG(RG)-1
2955 RETURN
3000 REM **************************
3005 REM * 'Put' Subroutine       *
3010 REM **************************
3015 REM * p    :check flag       *
3020 REM *      =22 check address *
3025 REM *      =23 check contents*
3030 REM **************************
3035 REM ------prepare display-------------------------------------
3040 LINE (116,149)-STEP(150,36),1,B
3045 LINE (116,161)-STEP(150,0),1
3050 LOCATE 20,SPOT:PRINT"Put Operation";
3055 LOCATE 22,SPOT:PRINT"Address :";
3060 LOCATE 23,SPOT:PRINT"Contents:";
3065 LOCATE 20,35:PRINT"Quit";
3070 GET (271,151)-STEP(8,8),LTR
3075 PUT (271,151),LTR,PRESET
3080 P=22
3081 rem [][][] color [][][]: changeclr=0
3085 C=-1:INS$=""
3090 C=C+1:REM --- BEGINNING OF ADDRESS INPUT LOOP ------------------------|
3095  PUT (192+C*8,(P-1)*8),CRSR,XOR
3100  A$=INKEY$ : IF A$="" THEN 3100
3105  A=ASC(A$)
3110  IF A$="Q" OR A$="q" THEN 3345
3111 rem [][][] color [][][]
3112  if A$="C" or A$="c" then 3155
3115  IF C=2 AND A<>13 AND A<>8 THEN SOUND 1900,3:GOTO 3100
3120  IF A=13 AND INS$="" THEN SOUND 100,3:GOTO 3100
3125 REM ---------- if p=22 "check address"  if p=23 "check contents"-------
3130  IF A=13 THEN PUT(192+C*8,(P-1)*8),CRSR,XOR:ON P-21 GOTO 3175,3225
3131 rem [][][] color [][][]: if a$="c" then 3155
3135  IF A=8 AND C=0 THEN SOUND 1900,3:GOTO 3100
3140  IF A=8 THEN PUT (192+C*8,(P-1)*8),CRSR,XOR:INS$=LEFT$(INS$,LEN(INS$)-1)
3145  IF A=8 THEN C=C-1:LOCATE P,SPOT+9+C:PRINT" ":GOTO 3095
3150  IF A<48 OR  A>57 THEN SOUND 100,3:GOTO 3100
3155  INS$=INS$+A$
3160  PUT (192+C*8,(P-1)*8),CRSR,XOR
3165  LOCATE P,SPOT+9+C:PRINT A$
3170 GOTO 3090:REM -- END OF INPUT LOOP -----------------------------------|
3175 REM
3180 REM --------- Error Checking of Address ------------------------------|
3185 REM
3190 RG=VAL(INS$)
3191 rem [][][] color [][][]
3192 if left$(ins$,1)="c" then changeclr=1:plt=val(right$(ins$,len(ins$)-1)):goto 3215
3195 IF RG>-1 AND RG<12 THEN 3215
3200 SOUND 100,4
3205 LOCATE P,SPOT+9:PRINT"   ";
3210 C=-1:GOTO 3085
3215 P=23 :REM go get contents
3220 GOTO 3085
3225 REM
3230 REM --------- Error Checking of Contents -----------------------------|
3235 REM
3240 CNTS=VAL(INS$)
3241 rem [][][] color [][][]
3242 if changeclr=1 then nuclr=cnts: COLOR cnts,plt :changeclr=0:goto 3350
3245 IF CNTS<0 OR CNTS>99 THEN 3200
3250 INS = 2:REG(RG)=0
3255 GET (1,RG*16+4)-STEP(38,12),WINDO
3260 PUT (1,RG*16+4),WINDO,XOR
3265 IF CNTS=16 THEN 3305
3270 IF CNTS>16 THEN 3315
3275 REM ----- Putting less than 16 ------------------------------------
3277 IF CNTS=0 AND MODFLAG=1 THEN LOCATE RG*2+2,3:PRINT REG(RG);
3280 FOR Y=0 TO CNTS-1
3285    REG(RG)=REG(RG)+1
3290    GOSUB 2800
3295 NEXT Y
3300 GOTO 3330
3305 REM ----- Putting exactly 16 [special case,needed to bypass chacks @2800 -
3310 REG(RG)=CNTS:GOSUB 2930:GOTO 3330
3315 REM ----- Putting more than 17 ------------------------------------
3320 REG(RG)=CNTS:GOSUB 2800
3325 REM ----- return to input loop ------------------------------------
3330 LOCATE 22,SPOT+9:PRINT"   ";
3335 LOCATE 23,SPOT+9:PRINT"   ";
3340 GOTO 3080
3345 REM
3350 REM --------- Prepare to return to previous mode ---------------------|
3355 REM
3360 GET (116,149)-STEP(186,36),WINDO
3365 PUT (116,149),WINDO,XOR
3370 RETURN
3375 CLS
4000 REM *********************************
4005 REM *  Edit Mode                    *
4010 REM *********************************
4015 REM * windo   :graphic array        *
4020 REM * col     :x pos for locate     *
4025 REM * ro      :y pos for locate     *
4030 REM * oldcol  :old value of col     *
4035 REM * oldro   :old value of ro      *
4040 REM * nc      :numb of char on line *
4045 REM * ins$    :instruction line     *
4050 REM * linen$  :line number string   *
4055 REM * linen   :val (linen$)         *
4060 REM * rg$     :reg number string    *
4065 REM * rg      :val (rg$)            *
4070 REM * gothru  :counter for parser   *
4075 REM * errflag :error flag           *
4080 REM *         =1 line number err    *
4085 REM *         =2 syntax err         *
4090 REM *         =3 reg number err     *
4095 REM *         =4 branching err      *
4096 REM * fileflag: (see 5200)          *
4100 REM * erro    :ro where err msg is  *
4105 REM * prog(x,y)   :array for program*
4110 REM * newprog(x,y):array that       *
4115 REM *               user is editing *
4120 REM *********************************
4125 REM ----------- initialization ------------------------------
4130 CLS
4135 COLOR 9,1
4140 REM ------ print options ------------------------------------
4145 LOCATE 21,7:PRINT"Editor";
4150 GET (0,159)-STEP(319,9),TOPW
4155 PUT (0,159),TOPW,PRESET
4160 LOCATE 23,7:PRINT"List    Exit    Quit    New";
4165 FOR Y=7 TO 31 STEP 8
4170  X=(Y-1)*8-1
4175   GET (X,175)-STEP(8,8),LTR
4180   PUT (X,175),LTR,PRESET
4185 NEXT Y
4190 REM ----- copy prog(x,y) into newprog(x,y) --------------------
4195 IF PROG(0,0)=0 THEN 4240
4200 FOR Y=0 TO 150
4205   IF PROG(Y,0)=0 THEN NEWPROG(Y,0)=0: GOTO 4225
4210   FOR X=0 TO 18
4215      NEWPROG(Y,X)=PROG(Y,X)
4220 NEXT X
4225 NEXT Y
4230 FIRST=1:LAST=NEWPROG(0,0) :REM *** variables for GOSUB
4235 GOSUB 8850 :REM *** display program
4240 REM ----- Beginning of Input Loop -----------------------------
4245 RO=1:COL=1
4250 PUT ((COL-1)*8,(RO-1)*8),CRSR,XOR
4255 A$=INKEY$:IF A$="" THEN 4255
4260 A=ASC(A$)
4265 B=0
4270 OLDCOL=COL:OLDRO=RO
4275 IF LEN(A$)=1 AND A<>8 THEN 4335
4280 B=ASC(RIGHT$(A$,1)) :REM *** used to check for movement keys
4285 IF A=8 OR B=75 THEN COL=COL-1
4290 IF A=8 AND COL>0 THEN LOCATE RO,COL:PRINT" "
4295 IF B=77 THEN COL=COL+1
4300 IF B=72 THEN RO=RO-1
4305 IF B=80 THEN RO=RO+1
4310 IF COL=20 THEN COL=1:RO=RO+1
4315 IF COL=0 THEN COL=18:RO=RO-1
4320 IF RO=0 THEN GOSUB 10310:GOTO 4245:REM scroll down
4325 IF RO=18 THEN GOSUB 10175:GOTO 4250:REM scroll up
4335 IF ((A=13 OR B=72 OR B=80) AND ERRFLAG<>0) THEN GOSUB 4975
4340 IF A=13 THEN 4425
4345 IF (B>71 AND B<81) OR A=8 THEN PUT ((OLDCOL-1)*8,(OLDRO-1)*8),CRSR,XOR:GOTO 4250
4350 IF COL=19 THEN SOUND 1900,3:GOTO 4255
4355 LOCATE RO,COL:PRINT LEFT$(A$,1)
4360 COL=COL+1
4365 GOTO 4250
4370 REM  ------ End of Input Loop -----------------------------
4375 REM *********************
4380 REM * Parser for Editor *
4385 REM *********************
4390 REM ------- routine to skip over spaces ------------------
4395 A=SCREEN(RO,NC)
4400 WHILE (A=SPACE AND NC<18)
4405    NC=NC+1
4410    A=SCREEN(RO,NC)
4415 WEND
4420 RETURN
4425 REM ------- check function selected --------------------
4430 INS$="":LINEN$="":NC=1:A=SCREEN(RO,NC)
4435 A$=CHR$(A)
4440 IF A$="E" OR A$="e" THEN CLS:GOTO 5000 : REM update prog
4445 IF A$="Q" OR A$="q" THEN CLS:GOTO 6000 : REM leave prog unchanged
4450 IF A$="L" OR A$="l" THEN GOSUB 9500:GOTO 4250
4455 IF A$="N" OR A$="n" THEN 5200
4460 REM ------- check if good line number ------------------
4462 PUT ((COL-1)*8,(RO-1)*8),CRSR,XOR
4464 GOSUB 4390
4466 IF NC=18 THEN COL=1:GOTO 4250
4470 NC=0
4475 A=SCREEN(RO,1)
4485 WHILE ((A>47 AND A<58) AND NC<4)
4490   NC=NC+1
4495   A=SCREEN(RO,NC)
4500   LINEN$=LINEN$+CHR$(A)
4505 WEND
4510 LINEN=VAL(LINEN$)
4515 IF LINEN$="" OR LINEN <1 OR LINEN>150 THEN ERRFLAG=1:GOTO 4895
4520 IF A<>SPACE THEN ERRFLAG=2:GOTO 4895
4525 REM ------- check if all spaces --------------------------
4530 GOSUB 4390
4535 IF NC=18 THEN 5045
4540 NC=NC-1
4545 REM -------- check instruction -------------------------------
4550 OLDNC=NC:A=SCREEN(RO,NC+1)
4555 WHILE ((A>65 AND A<79) OR (A>97 AND A<111)) AND NC<OLDNC+4
4560   NC=NC+1
4565   A=SCREEN(RO,NC)
4570   INS$=INS$+CHR$(A)
4575 WEND
4580 IF INS$="" THEN 4610
4585 IF ASC(RIGHT$(INS$,1))<>SPACE THEN 4610
4590 INS$=LEFT$(INS$,3)
4595 IF INS$="INC" OR INS$="inc" THEN INS=2:GOTO 4635
4600 IF INS$="DEB" OR INS$="deb" THEN INS=1:GOTO 4635
4605 IF INS$="END" OR INS$="end" THEN 4620
4610 ERRFLAG=2:GOTO 4895
4615 REM --------- check if any character after "end" statement------
4620 GOSUB 4390
4625 IF NC<>18 THEN ERRFLAG=2:GOTO 4895
4630 GOTO 4810
4635 REM -------- check register number ---------------------------
4640 GOSUB 4390
4645 IF NC=18 THEN ERRFLAG=3:GOTO 4895
4650 NC=NC-1
4655 A=SCREEN(RO,NC+1):OLDNC=NC:RG$=""
4660 WHILE ((A>47 AND A<58) AND NC<OLDNC+3)
4665   NC=NC+1
4670   A=SCREEN(RO,NC)
4675   RG$=RG$+CHR$(A)
4680 WEND
4685 IF OLDNC=NC THEN STOP:ERRFLAG=3:GOTO 4895
4690 IF NC=OLDNC+3 AND A<>SPACE THEN ERRFLAG=3:GOTO 4895
4695 RG=VAL(RG$)
4700 IF RG<0 OR RG>11 THEN ERRFLAG=3:GOTO 4895
4705 REM -------- check branching address -------------------------
4710 REM ---[ must go through loop three times ]-----------
4715 GOTHRU=3
4720 GOSUB 4390
4722 IF GOTHRU=1 AND NC<>18 THEN 4806
4725 NC=NC-1
4730 A=SCREEN(RO,NC+1):OLDNC=NC:RG$=""
4735 WHILE ((A>47 AND A<58) AND NC<OLDNC+4)
4740   NC=NC+1
4745   A=SCREEN(RO,NC)
4750   RG$=RG$+CHR$(A)
4755 WEND
4760 IF NC=OLDNC AND GOTHRU=3 THEN 4806
4765 IF NC=OLDNC AND GOTHRU=2 AND INS=1 THEN 4806
4770 IF NC<>OLDNC AND GOTHRU=2 AND INS=2 THEN 4806
4775 IF NC<>OLDNC AND GOTHRU=1 THEN 4806
4780 IF A<>SPACE THEN 4806
4785 RG=VAL(RG$)
4790 IF RG>150 THEN 4806
4795 GOTHRU=GOTHRU-1
4800 IF GOTHRU=0 THEN 4810
4805 GOTO 4720
4806 ERRFLAG=4:GOTO 4895
4810 REM ------- input line was suntatically correct --------
4815 REM ------- SAVE line into program array (newprog) -----
4820 IF LINEN>NEWPROG(0,0) THEN NEWPROG(0,0)=LINEN
4825 FLAG=1:NC=0
4830 FOR X=1 TO 18
4835   A=SCREEN(RO,X)
4837   NEWPROG(LINEN,X)=SPACE
4840   IF A=SPACE AND FLAG=1 THEN 4865 : REM ** skip over extra spaces
4845   IF A=SPACE AND FLAG=0 THEN FLAG=1
4850   IF A<>SPACE AND FLAG=1 THEN FLAG=0
4855   NC=NC+1
4860   NEWPROG(LINEN,NC)=A
4865 NEXT X
4870 NEWPROG(LINEN,0)=1: REM ** flag indicates if line exists
4875 REM ----- prepare to return to screen ---------------------------
4885 RO=RO+1:COL=1
4886 IF RO=18 THEN PUT ((OLDCOL-1)*8,(OLDRO-1)*8),CRSR,XOR:GOSUB 10175
4887 FILEFLAG=0
4890 GOTO 4250
4895 REM *************************
4900 REM * Error Msgs for Editor *
4905 REM *************************
4910 ERRO=RO
4915 PUT (152,(ERRO-1)*8),TRTLLF
4920 LOCATE ERRO,21
4925 SOUND 100,4
4930 ON ERRFLAG GOTO 4940,4945,4950,4955
4935 PRINT"bug in 4600,bad errflag":END
4940 PRINT"Bad Line Number":GOTO 4965
4945 PRINT"Syntax Error":GOTO 4965
4950 PRINT"Bad Register Number":GOTO 4965
4955 PRINT"Bad Branching Line":GOTO 4965
4960 REM ------- replace cursor to original spot, return ----------
4965 PUT ((COL-1)*8,(RO-1)*8),CRSR,XOR
4970 GOTO 4255
4975 REM ----- erase error messages --------------------
4980 LOCATE ERRO,20
4985 PRINT"                     "
4990 ERRFLAG=0:RETURN
5000 REM *********************
5001 REM * 'Exit' Subroutine *
5002 REM *********************
5003 REM --- copy newprog into prog ---
5005 IF NEWPROG(0,0)=0 THEN 5040
5010 FOR Y=0 TO NEWPROG(0,0)
5015 IF NEWPROG(Y,0)=0 THEN PROG(Y,0)=0:GOTO 5035
5020   FOR X=0 TO 18
5025     PROG(Y,X)=NEWPROG(Y,X)
5030   NEXT X
5035 NEXT Y
5040 GOTO 6000
5045 REM ******************************
5050 REM * Delete a Line from newprog *
5055 REM ******************************
5060 IF LINEN<>NEWPROG(0,0) THEN 5100
5065 REM ------ establish highest numbered line ----------
5070 LIMIT=NEWPROG(0,0)-1
5075 FOR Y=LIMIT TO 1 STEP -1
5080   IF NEWPROG(Y,0)=0 THEN 5090
5085   NEWPROG(0,0)=Y:GOTO 5100
5090 NEXT Y
5095 EDBOTTOM=NEWPROG(0,0)
5100 REM ------ erase line form array prog -------------------------
5105 FOR X=1 TO 18
5110   NEWPROG(LINEN,X)=0
5115 NEXT X
5120 NEWPROG(LINEN,0)=0: REM ** flag indicates if line exists
5125 GOTO 4875
5200 REM ***************************************
5205 REM * 'New' Subroutine   (EDITOR FUNCTION)*
5207 REM ***************************************
5210 REM * fileflag   :saving of file flag     *
5215 REM *            =0 latest version unsaved*
5220 REM *            =1 latest version saved  *
5225 REM ***************************************
5250 IF FILEFLAG=1 THEN 5375
5255 REM ----- user hasn't saved old program -----
5260 GET (174,39)-STEP(124,80),WINDO
5265 PUT (174,39),WINDO,XOR
5270 LOCATE 6,23:PRINT"Don't Forget";
5275 GET (174,39)-STEP(124,9),TOPW
5280 PUT (174,39),TOPW,PRESET
5285 LOCATE 8,23:PRINT"You haven't ";
5290 LOCATE 9,24:PRINT"saved your old";
5295 LOCATE 10,24:PRINT"program yet.";
5300 LOCATE 12,23:PRINT"Do you want";
5305 LOCATE 13,24:PRINT"to save it?";
5310 LOCATE 15,24:PRINT"Yes or No";
5315 GET (183,111)-STEP(8,8),LTR: PUT(183,111),LTR,PRESET
5325 GET (239,111)-STEP(8,8),LTR: PUT(239,111),LTR,PRESET
5330 A$=INKEY$:IF A$="" THEN 5330
5335 IF A$="N" OR A$="n" THEN 5375
5340 IF A$="Y" OR A$="y" THEN 5350
5345 SOUND 100,4:GOTO 5330
5350 REM ---- prepare to call Save Subroutine -----
5355 GET (116,149)-STEP(186,36),TOPW
5360 PUT (116,149),TOPW,XOR
5365 FLAG=1:GOSUB 6500 : REM ** go save
5370 PUT (116,149),TOPW,PSET
5375 REM ---- erase old program from memory --------
5380 GET (174,39)-STEP(124,80),WINDO
5385 PUT (174,39),WINDO,XOR
5390 FOR Y=0 TO 150
5395   FOR X= 0 TO 18
5400     PROG (Y,X)=0
5405     NEWPROG (Y,X)=0
5410   NEXT X
5415 NEXT Y
5420 EDTOP=0:EDBOTTOM=0
5425 GOTO 4000
5500 REM *********************
5510 REM * 'List' Subroutine * (EDITOR FUNCTION)   (see 9500)
5515 REM *********************
6000 REM ***************************************
6005 REM * Walk/Run Mode                       *
6010 REM ***************************************
6015 REM * modflag    :mode flag               *
6020 REM *            =0 Walk Mode             *
6025 REM *            =1 Run Mode              *
6030 REM *            =3 Step Mode             *
6035 REM * ins$       :instruction string      *
6040 REM * reg()      :array with reg contents *
6045 REM * rg         :register number         *
6050 REM * l          :vertical location       *
6055 REM * spot       :original column location*
6060 REM * col        :horizonatal location    *
6065 REM * fileflag   :saving of file flag     *
6070 REM *            =0 latest version unsaved*
6075 REM *            =1 latest version saved  *
6080 REM * oldregsflag:were registers saved?   *
6085 REM *            =0 must obtain new values*
6090 REM *            =1 old values stored     *
6092 REM * flag       :multipurpose            *
6095 REM ***************************************
6100 CLS:COLOR nuclr,0
6105 LOCATE 1,16
6110 IF MODFLAG THEN PRINT"Run Mode" ELSE PRINT"Walk Mode"
6115 REM ---- draw registers and pick values ----------------
6120 IF OLDREGSFLAG=0 THEN GOSUB 500:GOSUB 570
6125 REM ---- draw window and print options -----------------
6130 GOSUB 550:GOSUB 700
6135 IF OLDREGSFLAG=1 AND MODFLAG=1 THEN GOSUB 500:GOSUB 6705
6140 IF OLDREGSFLAG=1 AND MODFLAG=0 THEN GOSUB 450
6145 L=3
6150 IF PROG (0,0)>0 THEN L=13: GOSUB 8400 : REM display program
6155 GOSUB 8095
6160 L=L+1:INS$="":NC=-1
6165 IF L>15 AND PROG(0,0)=0 THEN GOSUB 8000
6170 IF L>15 AND PROG(0,0)>0 THEN GOSUB 8045
6175 IF MODFLAG=0 THEN PUT ((SPOT-3)*8,(L-1)*8),TRTLRT,XOR
6180 LOCATE L,SPOT,1: PRINT "? "
6185 REM ------ BEGINNING OF INPUT LOOP ----------------------
6186 NC=NC+1
6190 PUT (128+NC*8,(L-1)*8),CRSR,XOR
6195  A$=INKEY$ : IF A$="" THEN 6195
6200  A=ASC(A$)
6203  IF NC=6 AND A<>13 AND A<>8 THEN SOUND 1900,3:GOTO 6195
6205  IF A=13 THEN PUT(128+NC*8,(L-1)*8),CRSR,XOR:GOTO 6255
6210  IF A=8 AND NC=0 THEN SOUND 1900,3:GOTO 6195
6215  IF A=8 THEN PUT (128+NC*8,(L-1)*8),CRSR,XOR:INS$=LEFT$(INS$,LEN(INS$)-1)
6220  IF A=8 THEN NC=NC-1:LOCATE L,SPOT+1+NC:PRINT" ":GOTO 6190
6225  IF (A<47 OR A>58) AND (A<97 OR A>122) AND (A<65 OR A>90) AND A<>32 THEN SOUND 100,3:GOTO 6195
6230  INS$=INS$+A$
6235 PUT (128+NC*8,(L-1)*8),CRSR,XOR
6240 LOCATE L,SPOT+1+NC:PRINT A$
6245 COL=COL+1
6250 GOTO 6185:REM -- END OF INPUT LOOP ---------------------
6255 REM --------- Error Checking of Instruction-------------
6270 IF RUNERR=8 THEN GOSUB 7380
6275 IF MODFLAG=0 THEN PUT ((SPOT-3)*8,(L-1)*8),TRTLRT,XOR
6280 C$=LEFT$(INS$,3):LET INS=0
6285 IF C$="E" OR C$="e" AND NC=1 THEN 4000
6290 IF C$="X" OR C$="x" AND NC=1 THEN 11000
6295 IF (C$="W" OR C$="w") AND NC=1 AND MODFLAG=0 THEN GOSUB 7000:GOTO 6155
6300 IF (C$="R" OR C$="r") AND NC=1 AND MODFLAG=1 THEN GOSUB 7000:GOTO 6155
6305 IF C$="P" OR C$="p" AND NC=1 THEN GOSUB 3000:GOTO 6155
6310 IF C$="M" OR C$="m" AND NC=1 THEN GOTO 6345
6315 IF C$="L" OR C$="l" AND NC=1 THEN FLAG=0:GOSUB 6500:GOTO 6145
6320 IF C$="S" OR C$="s" AND NC=1 THEN FLAG=1:GOSUB 6500:GOTO 6145
6325 IF C$="CLS" OR C$="cls" AND NC=3 THEN GOSUB 8095:GOTO 6155
6327 IF C$="" THEN 6160
6330 L=L+1:LOCATE L,SPOT
6335 PRINT"-Illegal Command ":SOUND 100,3
6340 GOTO 6160
6345 REM ---- if leaving R Mode then switch back to Beans-------
6350 IF MODFLAG=0 THEN GOSUB 400:GOTO 1000
6355 OLDREGSFLAG=0:GOTO 1000
6500 REM **************************
6505 REM * 'Save/Load' Subroutine *
6510 REM **************************
6515 REM * naim$    :filename     *
6520 REM * fileflag :(see 6000)   *
6525 REM **************************
6530 LINE (116,149)-STEP(150,36),1,B
6531 LINE (116,161)-STEP(150,0),1
6532 LOCATE 20,SPOT:IF FLAG THEN PRINT"Save Program" ELSE PRINT"Load Program"
6533 LOCATE 22,SPOT:PRINT"disk drive: b:"
6534 LOCATE 23,SPOT:PRINT"filename:"
6535 LOCATE 20,35:PRINT"Quit";
6536 GET (271,151)-STEP(8,8),LTR
6537 PUT (271,151),LTR,PRESET
6538 DRIVE$="b:":C=0:P=22
6539 C=C+2:REM --- disk drive input loop ---------------------------------
6540 PUT (216+C*8,(P-1)*8),CRSR,XOR
6541 A$=INKEY$:IF A$="" THEN 6541
6542  A=ASC(A$)
6543  IF A$="Q" OR A$="q" THEN 6680
6544  IF C=2 AND A<>13 AND A<>8 THEN SOUND 1900,3:GOTO 6541
6545  IF A=13 AND DRIVE$<>"" THEN PUT (216+C*8,(P-1)*8),CRSR,XOR:GOTO 6565
6546  IF A=8 AND C=0 THEN SOUND 1900,3:GOTO 6541
6547  IF A=8 THEN PUT (216+C*8,(P-1)*8),CRSR,XOR:DRIVE$="":C=0:LOCATE P,SPOT+12+C:PRINT" ":LOCATE P,SPOT+13:PRINT" ":GOTO 6540
6548  IF (A<97 OR A>98) AND (A<65 OR A>66) THEN SOUND 100,3:GOTO 6541
6549  PUT (216+C*8,(P-1)*8),CRSR,XOR
6550  IF A$="A" OR A$="a" THEN DRIVE$="a:"
6551  IF A$="B" OR A$="b" THEN DRIVE$="b:"
6552 LOCATE P,SPOT+12+C:PRINT DRIVE$:GOTO 6539
6565 NAIM$="":C=-1:P=23
6570 C=C+1:REM --- beginning of filename input loop ---------------
6575  PUT (192+C*8,(P-1)*8),CRSR,XOR
6580  A$=INKEY$ : IF A$="" THEN 6580
6585  A=ASC(A$)
6590  IF A$="Q" OR A$="q" THEN 6680
6595  IF C=7 AND A<>13 AND A<>8 THEN SOUND 1900,3:GOTO 6580
6600  IF A=13 AND NAIM$="" THEN SOUND 100,3:GOTO 6580
6605  IF A=13 THEN PUT(192+C*8,(P-1)*8),CRSR,XOR:GOTO 6650
6610  IF A=8 AND C=0 THEN SOUND 1900,3:GOTO 6580
6615  IF A=8 THEN PUT (192+C*8,(P-1)*8),CRSR,XOR:NAIM$=LEFT$(NAIM$,LEN(NAIM$)-1)
6620  IF A=8 THEN C=C-1:LOCATE P,SPOT+9+C:PRINT" ":GOTO 6575
6625  IF (A<48 OR A>57) AND (A<97 OR A>122) AND (A<65 OR A>90) THEN SOUND 100,3:GOTO 6580
6630  NAIM$=NAIM$+A$
6635  PUT (192+C*8,(P-1)*8),CRSR,XOR
6640  LOCATE P,SPOT+9+C:PRINT A$
6645 GOTO 6570:REM -- END OF INPUT LOOP ----------------------
6650 REM --------- goto to disk ------------------------------
6655 NAIM$=DRIVE$+NAIM$+".rap"
6660 IF FLAG THEN 6675
6665 BLOAD NAIM$,VARPTR(PROG(0,0))
6670 GOTO 6680
6675 BSAVE NAIM$,VARPTR(PROG(0,0)),5700
6680 REM --------- Prepare to return to previous mode -------
6685 GET (116,149)-STEP(186,36),WINDO
6690 PUT (116,149),WINDO,XOR
6695 FILEFLAG=1
6700 RETURN
6705 REM ****************************
6710 REM * change Beans to Integers *
6715 REM ****************************
6720 OLDREGSFLAG=0
6725 FOR RG=0 TO 11
6730   IF REG(RG)>9 THEN LOCATE RG*2+2,2 ELSE LOCATE RG*2+2,3
6735   PRINT REG(RG);
6740   LINE (40,RG*16+3)-STEP(0,14),2
6745 NEXT RG
6750 RETURN
7000 REM *************************************
7005 REM * Interpret Code                    *
7010 REM *************************************
7015 REM * pcx            :element position  *
7020 REM * pcy            :line number       *
7025 REM * prog (pcy,pcx) :program array     *
7030 REM * xofins         :(see ????)        *
7035 REM * runerr         :(see 7380)        *
7040 REM *************************************
7045 REM --- list program from top -------------------------
7050 GOSUB 8400
7055 REM ---- find line number of instruction --------------
7060 IF PROG(0,0)=0 THEN RUNERR = 1:GOTO 7380
7065 PCY=1
7070 IF PROG(PCY,0)=0 THEN PCY = PCY + 1: GOTO 7070
7075 NEXTPCY=PCY
7080 REM ------------ get line number [linen$] -------------
7085 PCY=NEXTPCY:PCX=1:LINEN$="":INS$="":RG$="":BRAD$="":AXBRAD$=""
7090 WHILE (PROG (PCY,PCX) <> SPACE)
7095    LINEN$=LINEN$+CHR$(PROG(PCY,PCX))
7100    PCX=PCX+1
7105 WEND
7110 GOSUB 9000
7115 REM ----- go highlight line number --------------------
7120 LITEFLAG=1:GOSUB 9095
7125 REM ------------ get instruction [ins$] ---------------
7130 PCX=PCX+1 : REM skip space
7135 XOFINS=PCX
7140 WHILE (PROG(PCY,PCX) <> SPACE)
7145    INS$=INS$+CHR$(PROG(PCY,PCX))
7150    PCX=PCX+1
7155 WEND
7158 FOR T=1 TO DELAY:NEXT T
7160 REM ** if Run Mode want liteflag=1 / if Walk mode want liteflag=6
7165 IF INS$="end" OR INS$="END" THEN LITEFLAG=6-5*MODFLAG:GOSUB 9095:RETURN
7170 REM ----- get register number [rg$] -------------------
7175 PCX=PCX+1 : REM skip space
7180 WHILE (PROG(PCY,PCX) <> SPACE)
7185    RG$=RG$+CHR$(PROG(PCY,PCX))
7190    PCX=PCX+1
7195 WEND
7200 IF MODFLAG=0 THEN LITEFLAG=3 : GOSUB 9095
7205 IF RUNERR=8 THEN GOSUB 7380
7210 REM ----- get branching address [brad$] ---------------
7215 PCX=PCX+1 : REM skip space
7220 WHILE (PROG(PCY,PCX) <> SPACE)
7225    BRAD$=BRAD$+CHR$(PROG(PCY,PCX))
7230    PCX=PCX+1
7235 WEND
7240 REM -- check whether "DEB" command
7245 IF INS$="deb" OR INS$="DEB" THEN 7250 ELSE 7280
7250 REM ----- get auxiliary branching address [axbrad$] ----
7255 PCX=PCX+1 : REM skip space
7260 WHILE (PROG(PCY,PCX) <> SPACE)
7265    AXBRAD$=AXBRAD$+CHR$(PROG(PCY,PCX))
7270    PCX=PCX+1
7275 WEND
7280 REM ===
7285 REM === Interpret decoded line
7290 REM ===
7295 REM ---------- execute instruction ---------------------
7300 RG=VAL(RG$)
7305 IF INS$="inc" OR INS$="INC" THEN INS=2:GOSUB 2500
7310 IF INS$="deb" OR INS$="DEB" THEN INS=1:GOSUB 2500
7315 REM ---------- branching selection [nextpcy] -----------
7320 IF REG(RG)=0 AND AXBRFLAG=1 THEN LITEFLAG=5 ELSE LITEFLAG=4
7325 IF MODFLAG=0 THEN GOSUB 9095
7327 IF MODFLAG=1 THEN LITEFLAG=1:GOSUB 9095
7330 IF REG(RG)=0 AND AXBRFLAG=1 THEN NEXTPCY=VAL(AXBRAD$):GOTO 7340
7335 NEXTPCY=VAL(BRAD$):AXBRFLAG=0
7340 REM ---------- check branching address ------------------
7345 AXBRFLAG=0
7350 IF PROG(NEXTPCY,0)=0 THEN RUNERR=2:GOTO 7380
7355 REM ---------- check if needs to scroll to see next instruc. ----
7360 IF NEXTPCY>BOTTOMLINE OR NEXTPCY<TOPLINE THEN GOSUB 8500
7365 REM ---------- goto to next instruction -------------------------
7370 A$=INKEY$:IF A$="" THEN 7375 ELSE IF ASC(A$)=27 THEN RETURN
7375 GOTO 7080
7380 REM *******************************
7385 REM * Errors Msgs for Interpreter *
7386 REM *  and Save/Load (see error-trap)
7390 REM *******************************
7395 REM * runerr  :error flag         *
7400 REM *         =1 no program in mem*
7405 REM *         =2 bad branch       *
7406 REM *----- I/O errors ------------*
7407 REM *         =3 File not Found   *
7408 REM *         =4 Disk Full        *
7409 REM *         =5 Bad Disk         *
7410 REM *         =6 Disk not Ready   *
7411 REM *         =7 Write Protected  *
7412 REM *         =8 msg on screen    *(not an error)
7415 REM *******************************
7416 REM * These error messages are special because they stay on the
7417 REM *  screen until the user hits return
7418 REM *******************************
7420 LINE (116,149)-STEP(150,36),1,B
7425 LINE (116,161)-STEP(150,0),1
7426 IF RUNERR=8 THEN 7440
7427 IF RUNERR=3 THEN LOCATE 20,SPOT:PRINT"Loading Error":GOTO 7435
7428 IF RUNERR>3 THEN LOCATE 20,SPOT:PRINT"Saving Error":GOTO 7435
7430 LOCATE 20,SPOT:PRINT"Run Time Error"
7435 LOCATE 22,SPOT
7440 ON RUNERR GOTO 7450,7460,7470,7480,7490,7500,7510,7540
7445 PRINT"bug, unknown 'runerr'"RUNERR:GOTO 7445
7450 PRINT"No Program Chosen":SOUND 100,4
7455 RUNERR=8:GOTO 6155
7460 PRINT"Illegal Branching ";:LOCATE 23,SPOT+1:PRINT"on line"PCY;:SOUND 100,4
7465 RUNERR=8:GOTO 6155
7470 PRINT"File not Found":SOUND 100,4
7475 RUNERR=8:RETURN
7480 PRINT"Disk Full":SOUND 100,4
7485 RUNERR=8:RETURN
7490 PRINT"Defective Disk":SOUND 100,4
7495 RUNERR=8:RETURN
7500 PRINT"Disk not Ready":SOUND 100,4
7505 RUNERR=8:RETURN
7510 PRINT"Write Protected":SOUND 100,4
7515 RUNERR=8:RETURN
7535 REM --- clear message from screen ----
7540 GET (116,149)-STEP(150,36),WINDO
7545 PUT (116,149),WINDO,XOR
7550 RUNERR=0:RETURN
8000 REM *****************
8005 REM * Scroll Window * (for Step & Walk/Run w/o prgrm)
8010 REM *****************
8015 GOSUB 350
8020 GET (116,40)-STEP(148,99),WINDO
8025 WINDO(1)=WINDO(1)+4
8030 PUT (116,24),WINDO,PSET
8035 L=L-2
8040 RETURN
8045 REM ***************************
8050 REM * Scroll bottom two lines * (for Walk/Run w/ prgrm)
8055 REM ***************************
8065 GET (116,112)-STEP(148,17),TOPW
8070 LOCATE 13,16:PRINT"                 ";
8075 LOCATE 15,16:PRINT"                 ";
8080 PUT (116,96),TOPW,PSET
8085 L=L-2
8090 RETURN
8095 REM ****************
8100 REM * clear window *
8105 REM ****************
8110 IF PROG(0,0)=0 THEN L=3 ELSE L=12
8115 FOR Y=17 TO 1+L STEP -1
8120   LOCATE Y,SPOT
8125   PRINT"                 ";
8130 NEXT Y
8135 IF PROG(0,0)<>0 THEN L=13
8140 RETURN
8400 REM **********************************************
8405 REM * Print program inside window for Walk/Run   *
8410 REM **********************************************
8415 REM * topline :line number on top line of window *
8417 REM * bottomline :line number of bottommost displayed line *
8420 REM * nlines     :number of lines displayed      *
8425 REM **********************************************
8430 NLINES=0
8435 FOR Y=1 TO PROG(0,0)
8440 IF PROG(Y,0)=0 THEN 8485
8445 NLINES=NLINES+1
8450 IF NLINES=1 THEN TOPLINE=Y
8455 IF NLINES=10 THEN 8487
8460   FOR X=1 TO 18
8465      LOCATE 3+NLINES,SPOT+X-1
8470      PRINT CHR$(PROG(Y,X));
8475   NEXT X
8480 OLDY=Y
8485 NEXT Y
8487 FOR Y=NLINES TO 9
8490   LOCATE 4+Y,SPOT
8492   PRINT"                  ";
8495 NEXT Y
8497 BOTTOMLINE=OLDY
8498 LINE (117,22)-STEP(146,73),2,B
8499 RETURN
8500 REM *************************************
8505 REM * scrolling of prgram inside window *
8510 REM *************************************
8515 LINETOGO = NEXTPCY
8520 IF LINETOGO>BOTTOMLINE THEN 8540
8525 IF LINETOGO<TOPLINE THEN 8635
8530 IF MODFLAG=1 THEN LINE (117,22)-STEP(146,73),2,B : RETURN
8533 LINE (117,22)-STEP(146,73),2,B
8535 RETURN
8540 REM -------- scroll up --------------------------------
8543 LINE (117,22)-STEP(146,73),0,B
8545 GOSUB 350
8550 GET (116,40)-STEP(148,88),WINDO
8555 WINDO(1)=WINDO(1)+4
8560 PUT (116,24),WINDO,PSET
8565 GOSUB 8730
8570 REM --- get new topline ---
8575 C=0
8580 FOR Y=TOPLINE+1 TO PROG(0,0)
8585   IF PROG(Y,0)<>0 THEN C=C+1:TOPLINE=Y
8590   IF C=2 THEN 8600
8595 NEXT Y
8600 REM --- get new bottomline ---
8605 C=0
8610 FOR Y=BOTTOMLINE+1 TO PROG(0,0)
8615   IF PROG(Y,0)<>0 THEN C=C+1:BOTTOMLINE=Y
8620   IF C=2 THEN 8520
8625 NEXT Y
8630 GOTO 8520
8635 REM -------- scroll down -------------------------------
8640 GOSUB 350
8643 LINE (117,22)-STEP(146,73),0,B
8645 GET (116,22)-STEP(148,56),WINDO
8650 PUT (116,38),WINDO,PSET
8655 GET (116,23)-STEP(148,16),TOPW
8660 PUT (116,23),TOPW,XOR
8665 GOSUB 8790
8670 REM --- get new topline ---
8675 C=0
8680 FOR Y=TOPLINE-1 TO 1 STEP -1
8685   IF PROG(Y,0)<>0 THEN C=C+1:TOPLINE=Y
8690   IF C=2 THEN 8700
8695 NEXT Y
8700 REM --- get new bottomline ---
8705 C=0
8710 FOR Y=BOTTOMLINE-1  TO 1 STEP -1
8715   IF PROG(Y,0)<>0 THEN C=C+1:BOTTOMLINE=Y
8720   IF C=2 THEN 8520
8725 NEXT Y
8730 REM ---- add two missing lines after scrolling up ------
8735 C=0
8740 FOR Y = BOTTOMLINE+1 TO PROG(0,0)
8745   IF PROG(Y,0)=0 THEN 8780
8750   FOR X=1 TO 18
8755      LOCATE 11+C,SPOT+X-1
8760      PRINT CHR$(PROG(Y,X));
8765   NEXT X
8770   C=C+1
8775   IF C=2 THEN 8845
8780 NEXT Y
8783 LINE (117,22)-STEP(146,73),2,B
8785 RETURN
8790 REM ---- add two missing lines after scrolling down ----
8795 C=2
8800 FOR Y = TOPLINE-1 TO 1 STEP -1
8805   IF PROG(Y,0)=0 THEN 8840
8810   FOR X=1 TO 18
8815      LOCATE 3+C,SPOT+X-1
8820      PRINT CHR$(PROG(Y,X));
8825   NEXT X
8830   C=C-1
8835   IF C=0 THEN 8845
8840 NEXT Y
8843 LINE (117,22)-STEP(146,73),2,B
8845 RETURN
8850 REM *********************************
8855 REM * Print program inside Editor   *
8860 REM *  (scrolling 12000-12300)      *
8865 REM * edbottom  :editor bottom line *
8870 REM * edtop     :editor top line    *
8875 REM *********************************
8880 NLINES=0
8882 IF LAST>NEWPROG(0,0) THEN LAST=NEWPROG(0,0)
8885 FOR Y=FIRST TO LAST
8890 IF NEWPROG(Y,0)=0 THEN 8935
8895 NLINES=NLINES+1
8900 IF NLINES=1 THEN EDTOP=Y
8905 IF NLINES=20 THEN 8940
8910   FOR X=1 TO 18
8915      LOCATE NLINES,X
8920      PRINT CHR$(NEWPROG(Y,X));
8925   NEXT X
8930 EDBOTTOM=Y
8935 NEXT Y
8940 RETURN
9000 REM ************************
9005 REM * Program Highlighting *
9010 REM ************************
9015 REM -------- find row (thero) of instruction -------------------
9020 LINETOGO=VAL(LINEN$)
9025 X=1:THERO=4 : REM 4=top row if window
9030 FOR Y=TOPLINE TO BOTTOMLINE
9035 LNUM$=""
9040   IF PROG(Y,0)=0 THEN 9080
9045   WHILE (PROG(Y,X)<>SPACE)
9050      LNUM$=LNUM$+CHR$(PROG(Y,X))
9055      X=X+1
9060   WEND
9065   X=1
9070   IF VAL(LNUM$)=LINETOGO THEN 9085
9075   THERO=THERO+1
9080 NEXT Y
9085 RETURN
9090 LOCATE 2,2:PRINT"bug in 11030-11095":END
9095 REM **********************************
9100 REM * (Un)Highlight instruction line *
9105 REM **********************************
9110 REM * liteflag  :highlight what?     *
9115 REM *           =1 line number       *
9120 REM *           =2 instruction       *
9125 REM *           =3 register number   *
9130 REM *           =4 branching address *
9135 REM *           =5 auxbranching add. *
9140 REM *           =6 unhighlight 'end' *
9145 REM * xofins    :x pos of instruction*
9150 REM * xofbr     :x pos branching add.*
9155 REM **********************************
9160 IF LITEFLAG<4 THEN X=1
9165 IF LITEFLAG>3 THEN X=XOFINS
9170 IF LITEFLAG=6 THEN X=1
9175 LFLAG=LITEFLAG
9180 OLDX=X
9185 WHILE (PROG(LINETOGO,X)<>SPACE)
9190   X=X+1
9195 WEND
9200 DX=X-OLDX
9205   GET ((14+OLDX)*8-1,(THERO-1)*8-1)-STEP(DX*8,8),LTR
9210   PUT ((14+OLDX)*8-1,(THERO-1)*8-1),LTR,PRESET
9215 LFLAG=LFLAG-1
9220 IF LFLAG=0 THEN RETURN
9225 IF LITEFLAG=6 AND LFLAG=4 THEN LFLAG=1:X=XOFINS:FOR T=1 TO DELAY:NEXT T:GOTO 9180
9230 X=X+1: REM skip space
9235 IF LITEFLAG>3 AND LITEFLAG-LFLAG=2 THEN 9245
9240 GOTO 9180
9245 REM ------- highlight (aux)branching address -----------------
9250 IF AXBRFLAG=0 THEN 9280
9255 REM ------- skip over first address ---------------------------
9260 WHILE (PROG(LINETOGO,X)<>SPACE)
9265    X=X+1
9270 WEND
9275 X=X+1
9280 REM ------- highlight address (first or second) --------------
9285 XOFBR=X:OLDX=X
9290 WHILE (PROG(LINETOGO,X)<>SPACE)
9295   X=X+1
9300 WEND
9305 DX=X-OLDX
9310   GET ((14+OLDX)*8-1,(THERO-1)*8-1)-STEP(DX*8,8),LTR
9315   PUT ((14+OLDX)*8-1,(THERO-1)*8-1),LTR,PRESET
9320 FOR T=1 TO D2*DELAY:NEXT T
9325 REM ------ unhighlight address -----------------------
9330 X=XOFBR:OLDX=X
9335 WHILE (PROG(LINETOGO,X)<>SPACE)
9340   X=X+1
9345 WEND
9350 DX=X-OLDX
9355   GET ((14+OLDX)*8-1,(THERO-1)*8-1)-STEP(DX*8,8),LTR
9360   PUT ((14+OLDX)*8-1,(THERO-1)*8-1),LTR,PRESET
9365 RETURN
9500 REM ***************************************
9505 REM * 'List' Subroutine (EDITOR FUNCTION) *
9510 REM ***************************************
9515 REM * first :first line to be listed      *
9520 REM * last  :last line to be listed       *
9525 REM ***************************************
9528 PUT ((COL-1)*8,(RO-1)*8),CRSR,XOR
9530 GET (0,159)-STEP(319,33),WINDO
9535 PUT (0,159),WINDO,XOR
9540 REM ------ set up menu -------------------------------
9545 LOCATE 21,7:PRINT"Editor - List Mode    Quit";
9550 GET (0,158)-STEP(319,10),TOPW
9555 PUT (0,159),TOPW,PRESET
9560 LOCATE 23,6:PRINT"Initial Address:";
9565 LOCATE 24,6:PRINT"Final Address  :";
9567 GET (223,160)-STEP(7,8),LTR
9568 PUT (223,160),LTR,PRESET
9570 P=23
9575 C=-1:INS$=""
9580 C=C+1:REM --- beginning ot input loop  ---------------------
9585 PUT (168+C*8,(P-1)*8),CRSR,XOR
9590 A$=INKEY$ : IF A$="" THEN 9590
9595 A=ASC(A$)
9600 IF A$="Q" OR A$="q" THEN 9775
9605 IF C=3 AND A<>13 AND A<>8 THEN SOUND 1900,3:GOTO 9590
9610 IF A=13 AND INS$="" THEN SOUND 100,3:GOTO 9590
9615 REM ---------- if p=23 "initial" if p=24 "final" -------------
9620 IF A=13 THEN PUT(168+C*8,(P-1)*8),CRSR,XOR:ON P-22 GOTO 9665,9705
9625 IF A=8 AND C=0 THEN SOUND 1900,3:GOTO 9590
9630 IF A=8 THEN PUT (168+C*8,(P-1)*8),CRSR,XOR:INS$=LEFT$(INS$,LEN(INS$)-1)
9635 IF A=8 THEN C=C-1:LOCATE P,22+C:PRINT" ";:GOTO 9585
9640 IF A<48 OR  A>57 THEN SOUND 100,3:GOTO 9590
9645 INS$=INS$+A$
9650 PUT (168+C*8,(P-1)*8),CRSR,XOR
9655 LOCATE P,22+C:PRINT A$;
9660 GOTO 9580:REM -- END OF INPUT LOOP -------------------
9665 REM --------- Error Checking of Initial Address ------
9670 FIRST=VAL(INS$)
9675 IF FIRST<=NEWPROG(0,0) AND FIRST>0 THEN 9695
9680 SOUND 100,4
9685 LOCATE P,22:PRINT"    ";
9690 GOTO 9575
9695 P=24 :REM go get final address
9700 GOTO 9575
9705 REM --------- Error Checking of Final Address --------
9710 LAST=VAL(INS$)
9715 IF LAST>0 THEN 9735
9720 SOUND 100,4
9725 LOCATE P,22:PRINT"    ";
9730 C=-1:GOTO 9575
9735 REM --------- clear screen ---------------------------
9740 FOR Y= 19 TO 1 STEP -1
9745   LOCATE Y,1:PRINT"                  ";
9750 NEXT Y
9755 REM --------- list program ---------------------------
9760 IF LAST<FIRST THEN TEMP=LAST:LAST=FIRST:FIRST=TEMP
9765 GOSUB 8850
9767 RO=1
9770 REM ---- end of list subroutine ----------------------
9775 REM ------ prepare to return to Editor ---------------
9780 PUT (0,159),WINDO,PSET
9782 COL=1
9785 RETURN
10000 REM ********************************************
10005 REM * Obtain values for edtop and edbottom     *
10010 REM ********************************************
10015 REM * edbottom  :highest line number displayed *
10020 REM * edtop     :lowest line number displayed  *
10025 REM ********************************************
10030 OLDY=1
10035 REM ---- find edtop ----------------------------
10040 FOR Y=OLDY TO 17
10045   IF SCREEN (Y,1)<>SPACE THEN 10060
10050 NEXT Y
10055 EDTOP=0:GOTO 10100
10060 A$="":X=1:A=SCREEN(Y,X)
10065 WHILE (A<>SPACE)
10070   A$=A$+CHR$(A)
10075   X=X+1
10080   IF X=5 THEN OLDY=Y+1:GOTO 10040
10085   A=SCREEN(Y,X)
10090 WEND
10095 EDTOP=VAL(A$)
10100 REM ---- find edbottom -------------------------
10105 OLDY=17
10110 FOR Y=OLDY TO 1 STEP -1
10115   IF SCREEN (Y,1)<>SPACE THEN 10130
10120 NEXT Y
10125 EDBOTTOM=0:RETURN
10130 A$="":X=1:A=SCREEN(Y,X)
10135 WHILE (A<>SPACE)
10140   A$=A$+CHR$(A)
10145   X=X+1
10150   IF X=5 THEN OLDY=Y-1:GOTO 10110
10155   A=SCREEN(Y,X)
10160 WEND
10165 EDBOTTOM=VAL(A$)
10170 RETURN
10175 REM *****************************************************
10180 REM * Scroll Up in Editor (scrolls up one line )        *
10185 REM *****************************************************
10190 REM * edtop     :lowest line number displayed           *
10195 REM * edbottom  :highest line number displayed          *
10200 REM * oldcol    :(editor variable) col of cursor        *
10205 REM * oldro     :(editor variable) row of cursor        *
10210 REM *****************************************************
10215 PUT ((OLDCOL-1)*8,(OLDRO-1)*8),CRSR,XOR
10220 GOSUB 350: REM clear windo array
10225 GOSUB 10000
10230 GET (0,8)-STEP(144,128),WINDO
10235 WINDO(1)=WINDO(1)+6
10240 PUT (0,0),WINDO,PSET
10245 REM ------ add missing line to bottom --------------
10250 C=0:OLDY=EDBOTTOM
10255 IF EDBOTTOM=NEWPROG(0,0) THEN 10300
10260 FOR Y=EDBOTTOM+1 TO NEWPROG(0,0)
10265    IF NEWPROG(Y,0)=0 THEN 10295
10270    C=C+1
10275    FOR X=1 TO 18
10280       LOCATE 17,X:PRINT CHR$(NEWPROG(Y,X))
10285    NEXT X
10290    IF C=1 THEN 10300
10295 NEXT Y
10300 RO=RO-1:COL=1
10305 RETURN
10310 REM *****************************************************
10315 REM * Scroll Down in Editor (scrolls one line at a time)*
10320 REM *****************************************************
10325 REM * edtop     :lowest line number displayed           *
10330 REM * edbottom  :highest line number displayed          *
10335 REM * oldcol    :(editor variable) col of cursor        *
10340 REM * oldro     :(editor variable) row of cursor        *
10345 REM *****************************************************
10350 GOSUB 350 : REM clear windo array
10355 PUT ((OLDCOL-1)*8,(OLDRO-1)*8),CRSR,XOR
10360 GOSUB 10000
10365 IF EDTOP=0 THEN EDTOP=NEWPROG(0,0)+1
10370 GET (0,0)-STEP(144,127),WINDO
10375 PUT (0,8),WINDO,PSET
10380 GET (0,0)-STEP(144,7),WINDO
10385 PUT (0,0),WINDO,XOR
10390 REM ----- add missing lines to top ---------------
10395 C=0
10400 FOR Y=EDTOP-1 TO 1 STEP -1
10405    IF NEWPROG(Y,0)=0 THEN 10435
10410    C=C+1
10415    FOR X=1 TO 18
10420       LOCATE 1,X:PRINT CHR$(NEWPROG(Y,X));
10425    NEXT X
10430    IF C=1 THEN 10440
10435 NEXT Y
10440 RETURN
11000 REM ************************
11005 REM * eXample subroutine
11010 REM ************************
11090 REM -------- setup display -----------
11095 GET (116,21)-STEP(148,118),WINDO
11100 PUT (116,21),WINDO,XOR
11105 LOCATE 4,21:PRINT"Examples";
11110 LINE (115,33)-STEP(149,0),1
11115 LOCATE 6,16:PRINT"1. add ";
11120 LOCATE 8,16:PRINT"2. subtract";
11125 LOCATE 10,16:PRINT"3. multiply";
11130 LOCATE 12,16:PRINT"4. quit";
11135 LOCATE 17,19:PRINT"select (1-4)";
11150 REM -------- input loop ---------------
11155 A$=INKEY$:IF A$="" THEN 11155
11160 A=VAL(A$)
11165 IF A<1 OR A>4 THEN SOUND 100,3:GOTO 11155
11170 IF A=1 THEN NAIM$="add"
11175 IF A=2 THEN NAIM$="sub"
11180 IF A=3 THEN NAIM$="mult"
11200 REM --- prepare to return -------------
11205 PUT (116,21),WINDO,PSET
11210 IF A=4 THEN 6160
11215 REM --- go load program ---------------
11220 FLAG=0:DRIVE$="a:"
11225 GOSUB 6650:GOTO 6145
